﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.Linq;

namespace FocusExtender
{
    [
        TargetControlType(typeof(TextBox))
    ]
    public class TextBoxFocusExtender : ExtenderControl
    {
        public TextBoxFocusExtender(){}

        private string _focusCSSClass;
        private string _nofocusCSSClass;
        
        public string FocusCSSClass
        {
            get { return _focusCSSClass; }
            set { _focusCSSClass = value; }
        }
        public string NoFocusCSSClass
        {
            get { return _nofocusCSSClass; }
            set { _nofocusCSSClass = value; }
        }

        protected override IEnumerable<ScriptDescriptor>
                GetScriptDescriptors(System.Web.UI.Control targetControl)
        {
            ScriptBehaviorDescriptor descriptor = new ScriptBehaviorDescriptor("FocusExtender.ClientBehavior1", targetControl.ClientID);
            descriptor.AddProperty("FocusCSSClass", this.FocusCSSClass);
            descriptor.AddProperty("NoFocusCSSClass", this.NoFocusCSSClass);
            yield return descriptor;
        }

        // Generate the script reference
        protected override IEnumerable<ScriptReference>
                GetScriptReferences()
        {
            yield return new ScriptReference("FocusExtender.ClientBehavior1.js", this.GetType().Assembly.FullName);
        }
    }
}